<?php

namespace Drupal\flexible_descriptions;

use Drupal\Core\Entity\EntityTypeManagerInterface;
use Drupal\flexible_descriptions\Entity\FlexibleDescriptions;

/**
 * Provides common methods to work with description entity.
 */
class FlexibleDescriptionOperationsManager implements FlexibleDescriptionOperationsManagerInterface {

  /**
   * EntityTypeManager service.
   *
   * @var \Drupal\Core\Entity\EntityTypeManagerInterface
   */
  protected EntityTypeManagerInterface $entityTypeManager;

  /**
   * Constructs DescriptionEntityOperationsManager object.
   */
  public function __construct(EntityTypeManagerInterface $entity_type_manager) {
    $this->entityTypeManager = $entity_type_manager;
  }

  /**
   * {@inheritdoc}
   */
  public function createFlexibleDescription(array $field_data): void {
    $this->entityTypeManager->getStorage('flexible_description')->create($field_data)->save();
  }

  /**
   * {@inheritdoc}
   */
  public function updateFlexibleDescription(FlexibleDescriptions $flexible_description, string $description_text): void {
    $flexible_description->set('description_text', $description_text);
    $flexible_description->save();
  }

  /**
   * {@inheritDoc}
   */
  public function deleteFlexibleDescription(FlexibleDescriptions $flexible_description): void {
    $this->entityTypeManager->getStorage('flexible_description')->delete([$flexible_description]);
  }

}
